package com.tzld.piaoquan.recommend.server.service.rank;

import com.aliyun.odps.utils.StringUtils;
import com.tzld.piaoquan.recommend.server.service.rank.strategy.*;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Service
@Slf4j
public class RankRouter {
    @Autowired
    private RankService rankService;
    @Autowired
    private RankStrategy4Rankv2Model rankStrategy4Rankv2Model;
    @Autowired
    private RankStrategy4RankModel rankStrategy4RankModel;
    @Autowired
    private RankStrategy4Density rankStrategy4Density;
    @Autowired
    private RankStrategy4RegionMergeModelV536 rankStrategy4RegionMergeModelV536;
    @Autowired
    private RankStrategy4RegionMergeModelV546 rankStrategy4RegionMergeModelV546;
    @Autowired
    private RankStrategy4RegionMergeModelV547 rankStrategy4RegionMergeModelV547;
    @Autowired
    private RankStrategy4RegionMergeModelV548 rankStrategy4RegionMergeModelV548;
    @Autowired
    private RankStrategy4RegionMergeModelV551 rankStrategy4RegionMergeModelV551;
    @Autowired
    private RankStrategy4RegionMergeModelV552 rankStrategy4RegionMergeModelV552;
    @Autowired
    private RankStrategy4RegionMergeModelV553 rankStrategy4RegionMergeModelV553;
    @Autowired
    private RankStrategy4RegionMergeModelV562 rankStrategy4RegionMergeModelV562;
    @Autowired
    private RankStrategy4RegionMergeModelV563 rankStrategy4RegionMergeModelV563;
    @Autowired
    private RankStrategy4RegionMergeModelV564 rankStrategy4RegionMergeModelV564;
    @Autowired
    private RankStrategy4RegionMergeModelV565 rankStrategy4RegionMergeModelV565;
    @Autowired
    private RankStrategy4RegionMergeModelV566 rankStrategy4RegionMergeModelV566;
    @Autowired
    private RankStrategy4RegionMergeModelV567 rankStrategy4RegionMergeModelV567;
    @Autowired
    private RankStrategy4RegionMergeModelV999 rankStrategy4RegionMergeModelV999;
    @Autowired
    private RankStrategy4RegionMergeModelV569 rankStrategy4RegionMergeModelV569;
    @Autowired
    private RankStrategy4RegionMergeModelV650 rankStrategy4RegionMergeModelV650;
    @Autowired
    private RankStrategy4RegionMergeModelV654 rankStrategy4RegionMergeModelV654;
    @Autowired
    private RankStrategy4RegionMergeModelV655 rankStrategy4RegionMergeModelV655;
    @Autowired
    private RankStrategy4RegionMergeModelV656 rankStrategy4RegionMergeModelV656;
    @Autowired
    private FestivalStrategy4RankModel festivalStrategy4RankModel;

    @Autowired
    private RankStrategyFlowThompsonModel rankStrategyFlowThompsonModel;
    @Autowired
    private RankStrategy4RegionMerge rankStrategy4RegionMerge;
    @Autowired
    private RankStrategy4ShareDeepAndWidth rankStrategy4ShareDeepAndWidth;

    public RankResult rank(RankParam param) {
        String abCode = param.getAbCode();
        if (StringUtils.isBlank(abCode)) {
            return rankService.rank(param);
        }
        switch (abCode) {
            case "60105": // 551
                return rankStrategy4RegionMergeModelV551.rank(param); // 60105 新模型自动更新 实验关闭
            case "60106": // 552
                return rankStrategy4RegionMergeModelV552.rank(param); // 60106 新模型自动更新+样本采样 实验关闭
            case "60107": // 553
                return rankStrategy4RegionMergeModelV553.rank(param); // 60107 历史内容召回 实验关闭
            case "60112": // 562
                return rankStrategy4RegionMergeModelV562.rank(param); // 60112 + vov公式 实验关闭
            case "60101":
                return rankStrategy4RankModel.rank(param); // 实验不存在
            case "60113": // 563
                return rankStrategy4RegionMergeModelV563.rank(param); // 60113 CF召回 doing
            case "60114": // 564
                return rankStrategy4RegionMergeModelV564.rank(param); // 60114 排序r-cnt实验 doing
            case "60115": // 565
                return rankStrategy4RegionMergeModelV565.rank(param); // 60115 VoV排序 v2 实验关闭
            case "60116": // 566
                return rankStrategy4RegionMergeModelV566.rank(param); // 60116 流量池数据汤姆森 实验关闭
            case "60117": // 567
                return rankStrategy4RegionMergeModelV567.rank(param); // 60117 cf叠加r-cnt模型 doing
            case "60118": // 568
                return rankStrategy4RegionMergeModelV999.rank(param); // rov fm模型 60118 实验关闭
            case "60119": // 569
                return rankStrategy4RegionMergeModelV569.rank(param); // rov fm模型 60119 实验关闭
            case "60120": // 576
                return rankStrategy4RegionMerge.rank(param); // 地域召回实时性 实验关闭
            case "60121": // 536
                return rankStrategy4RegionMergeModelV536.rank(param); // vor统计量 doing
            case "60122": // 537
                return rankStrategy4RegionMergeModelV546.rank(param); // 新实验 实验关闭
            case "60124": // 546
                return rankStrategy4RegionMergeModelV546.rank(param); // 新实验+时间倾向24小时 实验关闭
            case "60125": // 547
                return rankStrategy4RegionMergeModelV547.rank(param); // 新实验+时间倾向24小时+0.6 实验关闭
            case "60126": // 548
                return rankStrategy4RegionMergeModelV548.rank(param); // 新实验+排序分子用全部回流+召回汤姆森 实验关闭
            case "60130": // 算法祝福类内容召回 实验关闭
            case "60131": // 算法祝福类内容召回（密度提升） 实验关闭
            case "60132": // 算法祝福类内容召回（概率提升） 实验关闭
                return festivalStrategy4RankModel.rank(param);
            case "60150": // 645
                return rankStrategy4ShareDeepAndWidth.rank(param); // 分享深度、广度内容召回 实验关闭
            case "60151": // 650
                return rankStrategy4RegionMergeModelV650.rank(param); // 基于SRT和Title的CB 实验关闭
            case "60654": // 654
                return rankStrategy4RegionMergeModelV654.rank(param); // 60654 + CF-ROVn 实验关闭
            case "60655": // 655
                return rankStrategy4RegionMergeModelV655.rank(param); // 60655 + CF-ROVn - sim - return 实验关闭
            case "60656": // 656
                return rankStrategy4RegionMergeModelV656.rank(param); // 60656 算法实验上线流程模拟 实验关闭
            default:
                break;
        }
        return rankService.rank(param);
    }
}

